//----- The Atrium         Miller 12/05/92
//
//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

#include "Atr-Tex.INC"
#include "Atr-Part.INC"

//--- Left Wing Section of Building
#declare LREnds =
union {
  object { RoundF rotate y*-90 translate x*-9 }
  object { RoundF translate <-18, 0, -21> }
  object { Frame7 translate <-9, 0, -13> }
  object { Frame7 translate <-9, 0, -17> }
  object { SCRib scale <1, 1, 6> translate <-9, 0, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 3, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 6, -15> }	 
  object { SCRib scale <1, 1, 6> translate <-9, 9, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 12, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 15, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 18, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 21, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 24, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 27, -15> }
  object { SCRib scale <1, 1, 6> translate <-9, 30, -15> }
  object { SCPanel scale <1, 1, 6> translate <-9, 28.5, -15> }
  object { SCPanel scale <1, 1, 6> translate <-9, 13.5, -15> }
  object { SCGlass scale <1, 1, 6> translate <-9, 15, -15> }

  object { Frame7 translate <-27, 0, 9> }
  object { Frame7 translate <-27, 0, 5> }
  object { Frame7 translate <-27, 0, 1> }
  object { Frame7 translate <-27, 0, -3> }
  object { Frame7 translate <-27, 0, -7> }
  object { Frame7 translate <-27, 0, -11> }
  object { Frame7 translate <-27, 0, -15> }
  object { Frame7 translate <-27, 0, -19> }

  object { SCRib scale <1, 1, 15> translate <-27, 0, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 3, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 6, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 9, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 12, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 15, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 18, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 21, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 24, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 27, -6> }
  object { SCRib scale <1, 1, 15> translate <-27, 30, -6> }
  object { SCPanel scale <1, 1, 15> translate <-27, 28.5, -6> }
  object { SCPanel scale <1, 1, 15> translate <-27, 13.5, -6> }
  object { SCGlass scale <1, 1, 15> translate <-27, 15, -6> }
  box { -1, 1 scale <9, 15, 0.2> translate <-18, 15, 9> texture { RoofColor } }
  //--- Roof
  object {
    union {
      object { Disk_Y scale <9, 0.1, 9> translate <-9, 30, 0> }
      object { Disk_Y scale <9, 0.1, 9> translate <-18, 30, -21> }
      box { -1, 1 scale <9, 0.1, 15> translate <-18, 30, -6> }
    }
    texture { RoofColor }
    bounded_by { box { -1, 1 scale <14.4, 0.2, 20.4> translate <-13.6, 30, -10.2> } }
  }
  bounded_by { box { -1, 1 scale <14.4, 16, 20.4> translate <-13.6, 15, -10.2> } }
}

//----Complete Front Entrance with Both upper wings
union {
  union {
    union {
      object { ENT1 translate z*-15 }
      object { ENT1 translate z*15 }
      bounded_by { box { -1, 1 scale <13, 31.3, 16> translate y*31 } }
    }
    union {
      object { InArch translate <0, 48, -10> }
      object { InArch translate <0, 48, -5> }
      object { InArch translate <0, 48, 0> } 
      object { InArch translate <0, 48, 5> }
      object { InArch translate <0, 48, 10> }
      object { ACGlass }
      bounded_by { box { -1, 1 scale <14, 10, 12> translate y*52 } }
    }
    object { LeftWing translate <-12, 30, -10> }
    object { LeftWing rotate y*180 translate <12, 30, -10> }
    object { FSWalls }
    object { SGWalls }
    bounded_by { box { -1, 1 scale <41, 31.3, 16> translate y*31 } }
  }
  object { LREnds translate <-12, 0, -15> }
  object { LREnds rotate y*90 translate <42, 0, -33> } // Modified by me - CjF
  rotate y*10
  
}